Index: uspace/srv/hid/display/types/display/display.h
===================================================================
--- uspace/srv/hid/display/types/display/display.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/types/display/display.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,4 +46,5 @@
 #include "cursor.h"
 #include "clonegc.h"
+#include "seat.h"
 #include "window.h"
 
@@ -62,4 +63,8 @@
 	/** Clients (of ds_client_t) */
 	list_t clients;
+	/** WM clients (of ds_wmclient_t) */
+	list_t wmclients;
+	/** CFG clients (of ds_cfgclient_t) */
+	list_t cfgclients;
 
 	/** Next ID to assign to a window.
@@ -71,4 +76,6 @@
 	 */
 	ds_wnd_id_t next_wnd_id;
+	/** Next ID to assign to a seat */
+	ds_seat_id_t next_seat_id;
 	/** Input service */
 	input_t *input;
@@ -83,4 +90,7 @@
 	list_t ddevs;
 
+	/** Input device configuration entries (of ds_idevcfg_t) */
+	list_t idevcfgs;
+
 	/** Background color */
 	gfx_color_t *bg_color;
@@ -94,4 +104,7 @@
 	/** Bounding rectangle */
 	gfx_rect_t rect;
+
+	/** Maximize rectangle */
+	gfx_rect_t max_rect;
 
 	/** Backbuffer bitmap or @c NULL if not double-buffering */
Index: uspace/srv/hid/display/types/display/idev.h
===================================================================
--- uspace/srv/hid/display/types/display/idev.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/types/display/idev.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server input device type
+ */
+
+#ifndef TYPES_DISPLAY_IDEV_H
+#define TYPES_DISPLAY_IDEV_H
+
+#include <types/common.h>
+
+typedef sysarg_t ds_idev_id_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/display/types/display/idevcfg.h
===================================================================
--- uspace/srv/hid/display/types/display/idevcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/types/display/idevcfg.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server input device configuration type
+ */
+
+#ifndef TYPES_DISPLAY_IDEVCFG_H
+#define TYPES_DISPLAY_IDEVCFG_H
+
+#include <adt/list.h>
+#include <loc.h>
+
+/** Display server input device configuration */
+typedef struct ds_idevcfg {
+	/** Parent display */
+	struct ds_display *display;
+	/** Link to display->idevcfgs */
+	link_t ldispidcfgs;
+	/** Link to seat->idevcfgs */
+	link_t lseatidcfgs;
+	/** Service ID */
+	service_id_t svc_id;
+	/** Seat to which this device is assigned */
+	struct ds_seat *seat;
+} ds_idevcfg_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/display/types/display/ptd_event.h
===================================================================
--- uspace/srv/hid/display/types/display/ptd_event.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/types/display/ptd_event.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,9 +42,13 @@
 	PTD_ABS_MOVE,
 	PTD_PRESS,
-	PTD_RELEASE
+	PTD_RELEASE,
+	PTD_DCLICK
 } ptd_event_type_t;
 
 /** Pointing device event */
 typedef struct {
+	/** Positioning device ID */
+	unsigned pos_id;
+	/** PTD event type */
 	ptd_event_type_t type;
 	/** Button number for PTD_PRESS or PTD_RELEASE */
Index: uspace/srv/hid/display/types/display/seat.h
===================================================================
--- uspace/srv/hid/display/types/display/seat.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/types/display/seat.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,6 @@
 #include <gfx/coord.h>
 
+typedef sysarg_t ds_seat_id_t;
+
 /** Display server seat */
 typedef struct ds_seat {
@@ -46,4 +48,10 @@
 	/** Link to display->seats */
 	link_t lseats;
+	/** Seat ID */
+	ds_seat_id_t id;
+	/** Seat name */
+	char *name;
+	/** Input device configurations mapping to this seat */
+	list_t idevcfgs;
 	/** Window this seat is focused on */
 	struct ds_window *focus;
Index: uspace/srv/hid/display/types/display/window.h
===================================================================
--- uspace/srv/hid/display/types/display/window.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/types/display/window.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -79,4 +79,8 @@
 	/** Minimum size */
 	gfx_coord2_t min_size;
+	/** Normal rectangle (when not maximized or minimized) */
+	gfx_rect_t normal_rect;
+	/** Normal display position (when not maximized or minimized) */
+	gfx_coord2_t normal_dpos;
 	/** Window ID */
 	ds_wnd_id_t id;
@@ -99,6 +103,12 @@
 	/** Original position before started to move or resize the window */
 	gfx_coord2_t orig_pos;
+	/** Positioning device that started the move or resize */
+	sysarg_t orig_pos_id;
 	/** Window resize type (if state is dsw_resizing) */
 	display_wnd_rsztype_t rsztype;
+	/** Window caption */
+	char *caption;
+	/** Number of foci */
+	unsigned nfocus;
 } ds_window_t;
 
Index: uspace/srv/hid/display/types/display/wmclient.h
===================================================================
--- uspace/srv/hid/display/types/display/wmclient.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/srv/hid/display/types/display/wmclient.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,74 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup display
+ * @{
+ */
+/**
+ * @file Display server WM client type
+ */
+
+#ifndef TYPES_DISPLAY_WMCLIENT_H
+#define TYPES_DISPLAY_WMCLIENT_H
+
+#include <adt/list.h>
+#include <wndmgt.h>
+
+/** Display server WM client callbacks */
+typedef struct {
+	void (*ev_pending)(void *);
+} ds_wmclient_cb_t;
+
+/** Display server WM client */
+typedef struct ds_wmclient {
+	/** Parent display */
+	struct ds_display *display;
+	/** Callbacks */
+	ds_wmclient_cb_t *cb;
+	/** Callback argument */
+	void *cb_arg;
+	/** Link to @c display->wmclients */
+	link_t lwmclients;
+	/** Event queue (of ds_window_ev_t) */
+	list_t events;
+} ds_wmclient_t;
+
+/** WM client event queue entry */
+typedef struct {
+	/** Link to event queue */
+	link_t levents;
+	/** WM client to which the event is delivered */
+	ds_wmclient_t *wmclient;
+	/** Event */
+	wndmgt_ev_t event;
+} ds_wmclient_ev_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/display/window.c
===================================================================
--- uspace/srv/hid/display/window.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/display/window.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -44,8 +44,11 @@
 #include <memgfx/memgc.h>
 #include <stdlib.h>
+#include <str.h>
+#include <wndmgt.h>
 #include "client.h"
 #include "display.h"
 #include "seat.h"
 #include "window.h"
+#include "wmclient.h"
 
 static void ds_window_invalidate_cb(void *, gfx_rect_t *);
@@ -64,10 +67,10 @@
  * @param client Client owning the window
  * @param params Window parameters
- * @param rgc Place to store pointer to new GC.
+ * @param rwnd Place to store pointer to new window.
  *
  * @return EOK on success or an error code
  */
 errno_t ds_window_create(ds_client_t *client, display_wnd_params_t *params,
-    ds_window_t **rgc)
+    ds_window_t **rwnd)
 {
 	ds_window_t *wnd = NULL;
@@ -85,4 +88,13 @@
 	}
 
+	/* Caption */
+	wnd->caption = str_dup(params->caption);
+	if (wnd->caption == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	wnd->flags = params->flags;
+
 	ds_client_add_window(client, wnd);
 	ds_display_add_window(client->display, wnd);
@@ -90,4 +102,6 @@
 	gfx_bitmap_params_init(&bparams);
 	bparams.rect = params->rect;
+
+	/* Allocate window bitmap */
 
 	dgc = ds_display_get_gc(wnd->display);
@@ -122,5 +136,4 @@
 	wnd->gc = mem_gc_get_ctx(wnd->mgc);
 	wnd->cursor = wnd->display->cursor[dcurs_arrow];
-	wnd->flags = params->flags;
 
 	if ((params->flags & wndf_setpos) != 0) {
@@ -133,6 +146,11 @@
 	}
 
-	seat = ds_display_first_seat(client->display);
-
+	/* Determine which seat should own the window */
+	if (params->idev_id != 0)
+		seat = ds_display_seat_by_idev(wnd->display, params->idev_id);
+	else
+		seat = ds_display_default_seat(wnd->display);
+
+	/* Is this a popup window? */
 	if ((params->flags & wndf_popup) != 0)
 		ds_seat_set_popup(seat, wnd);
@@ -140,12 +158,22 @@
 		ds_seat_set_focus(seat, wnd);
 
+	/* Is this window a panel? */
+	if ((params->flags & wndf_avoid) != 0)
+		ds_display_update_max_rect(wnd->display);
+
 	(void) ds_display_paint(wnd->display, NULL);
 
-	*rgc = wnd;
+	*rwnd = wnd;
 	return EOK;
 error:
 	if (wnd != NULL) {
+		ds_client_remove_window(wnd);
+		ds_display_remove_window(wnd);
+		if (wnd->mgc != NULL)
+			mem_gc_delete(wnd->mgc);
 		if (wnd->bitmap != NULL)
 			gfx_bitmap_destroy(wnd->bitmap);
+		if (wnd->caption != NULL)
+			free(wnd->caption);
 		free(wnd);
 	}
@@ -163,8 +191,13 @@
 
 	disp = wnd->display;
+
+	ds_window_unfocus(wnd);
 
 	ds_client_remove_window(wnd);
 	ds_display_remove_window(wnd);
 
+	if ((wnd->flags & wndf_avoid) != 0)
+		ds_display_update_max_rect(disp);
+
 	mem_gc_delete(wnd->mgc);
 
@@ -172,4 +205,5 @@
 		gfx_bitmap_destroy(wnd->bitmap);
 
+	free(wnd->caption);
 	free(wnd);
 
@@ -183,8 +217,5 @@
 void ds_window_bring_to_top(ds_window_t *wnd)
 {
-	ds_display_t *disp = wnd->display;
-
-	ds_display_remove_window(wnd);
-	ds_display_add_window(disp, wnd);
+	ds_display_window_to_top(wnd);
 	(void) ds_display_paint(wnd->display, NULL);
 }
@@ -198,4 +229,14 @@
 {
 	return wnd->gc;
+}
+
+/** Determine if window is visible.
+ *
+ * @param wnd Window
+ * @return @c true iff window is visible
+ */
+bool ds_window_is_visible(ds_window_t *wnd)
+{
+	return (wnd->flags & wndf_minimized) == 0;
 }
 
@@ -212,5 +253,9 @@
 	gfx_rect_t crect;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_paint");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "ds_window_paint");
+
+	/* Skip painting the window if not visible */
+	if (!ds_window_is_visible(wnd))
+		return EOK;
 
 	if (rect != NULL) {
@@ -357,5 +402,5 @@
 	bool newr;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_repaint_preview");
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "ds_window_repaint_preview");
 
 	/*
@@ -401,6 +446,8 @@
  * @param wnd Window
  * @param pos Position where mouse button was pressed
- */
-static void ds_window_start_move(ds_window_t *wnd, gfx_coord2_t *pos)
+ * @param pos_id Positioning device ID
+ */
+static void ds_window_start_move(ds_window_t *wnd, gfx_coord2_t *pos,
+    sysarg_t pos_id)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_start_move (%d, %d)",
@@ -411,4 +458,5 @@
 
 	wnd->orig_pos = *pos;
+	wnd->orig_pos_id = pos_id;
 	wnd->state = dsw_moving;
 	wnd->preview_pos = wnd->dpos;
@@ -440,4 +488,5 @@
 	wnd->dpos = nwpos;
 	wnd->state = dsw_idle;
+	wnd->orig_pos_id = 0;
 
 	(void) ds_display_paint(wnd->display, NULL);
@@ -455,5 +504,5 @@
 	gfx_rect_t old_rect;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_update_move (%d, %d)",
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "ds_window_update_move (%d, %d)",
 	    (int) pos->x, (int) pos->y);
 
@@ -474,7 +523,8 @@
  * @param rsztype Resize type (which part of window is being dragged)
  * @param pos Position where mouse button was pressed
+ * @param pos_id Positioning device ID
  */
 static void ds_window_start_resize(ds_window_t *wnd,
-    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos)
+    display_wnd_rsztype_t rsztype, gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	ds_seat_t *seat;
@@ -487,11 +537,15 @@
 		return;
 
+	/* Determine which seat started the resize */
+	seat = ds_display_seat_by_idev(wnd->display, pos_id);
+	if (seat == NULL)
+		return;
+
 	wnd->orig_pos = *pos;
+	wnd->orig_pos_id = pos_id;
 	wnd->state = dsw_resizing;
 	wnd->rsztype = rsztype;
 	wnd->preview_rect = wnd->rect;
 
-	// XXX Need client to tell us which seat started the resize!
-	seat = ds_display_first_seat(wnd->display);
 	ctype = display_cursor_from_wrsz(rsztype);
 	ds_seat_set_wm_cursor(seat, wnd->display->cursor[ctype]);
@@ -523,7 +577,10 @@
 	ds_client_post_resize_event(wnd->client, wnd, &nrect);
 
-	// XXX Need to know which seat started the resize!
-	seat = ds_display_first_seat(wnd->display);
-	ds_seat_set_wm_cursor(seat, NULL);
+	/* Determine which seat started the resize */
+	seat = ds_display_seat_by_idev(wnd->display, wnd->orig_pos_id);
+	if (seat != NULL)
+		ds_seat_set_wm_cursor(seat, NULL);
+
+	wnd->orig_pos_id = 0;
 
 	(void) ds_display_paint(wnd->display, NULL);
@@ -541,5 +598,5 @@
 	gfx_rect_t old_rect;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_update_resize (%d, %d)",
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "ds_window_update_resize (%d, %d)",
 	    (int) pos->x, (int) pos->y);
 
@@ -580,4 +637,6 @@
  * @param wnd Window
  * @param event Position event
+ *
+ * @return EOK on success or an error code
  */
 errno_t ds_window_post_pos_event(ds_window_t *wnd, pos_event_t *event)
@@ -585,8 +644,9 @@
 	pos_event_t tevent;
 	gfx_coord2_t pos;
+	sysarg_t pos_id;
 	gfx_rect_t drect;
 	bool inside;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG,
+	log_msg(LOG_DEFAULT, LVL_DEBUG2,
 	    "ds_window_post_pos_event type=%d pos=%d,%d", event->type,
 	    (int) event->hpos, (int) event->vpos);
@@ -594,19 +654,24 @@
 	pos.x = event->hpos;
 	pos.y = event->vpos;
+	pos_id = event->pos_id;
 	gfx_rect_translate(&wnd->dpos, &wnd->rect, &drect);
 	inside = gfx_pix_inside_rect(&pos, &drect);
 
-	if (event->type == POS_PRESS && event->btn_num == 2 && inside) {
-		ds_window_start_move(wnd, &pos);
+	if (event->type == POS_PRESS && event->btn_num == 2 && inside &&
+	    (wnd->flags & wndf_maximized) == 0) {
+		ds_window_start_move(wnd, &pos, pos_id);
 		return EOK;
 	}
 
 	if (event->type == POS_RELEASE) {
-		if (wnd->state == dsw_moving) {
+		/* Finish move/resize if they were started by the same seat */
+		if (wnd->state == dsw_moving &&
+		    ds_window_orig_seat(wnd, pos_id)) {
 			ds_window_finish_move(wnd, &pos);
 			return EOK;
 		}
 
-		if (wnd->state == dsw_resizing) {
+		if (wnd->state == dsw_resizing &&
+		    ds_window_orig_seat(wnd, pos_id)) {
 			ds_window_finish_resize(wnd, &pos);
 			return EOK;
@@ -615,10 +680,13 @@
 
 	if (event->type == POS_UPDATE) {
-		if (wnd->state == dsw_moving) {
+		/* Update move/resize if they were started by the same seat */
+		if (wnd->state == dsw_moving &&
+		    ds_window_orig_seat(wnd, pos_id)) {
 			ds_window_update_move(wnd, &pos);
 			return EOK;
 		}
 
-		if (wnd->state == dsw_resizing) {
+		if (wnd->state == dsw_resizing &&
+		    ds_window_orig_seat(wnd, pos_id)) {
 			ds_window_update_resize(wnd, &pos);
 			return EOK;
@@ -637,10 +705,30 @@
  *
  * @param wnd Window
+ * @return EOK on success or an error code
  */
 errno_t ds_window_post_focus_event(ds_window_t *wnd)
 {
+	display_wnd_focus_ev_t efocus;
+	errno_t rc;
+	ds_wmclient_t *wmclient;
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_post_focus_event");
 
-	return ds_client_post_focus_event(wnd->client, wnd);
+	/* Increase focus counter */
+	++wnd->nfocus;
+	efocus.nfocus = wnd->nfocus;
+
+	rc = ds_client_post_focus_event(wnd->client, wnd, &efocus);
+	if (rc != EOK)
+		return rc;
+
+	/* Notify window managers about window information change */
+	wmclient = ds_display_first_wmclient(wnd->display);
+	while (wmclient != NULL) {
+		ds_wmclient_post_wnd_changed_event(wmclient, wnd->id);
+		wmclient = ds_display_next_wmclient(wmclient);
+	}
+
+	return EOK;
 }
 
@@ -648,10 +736,30 @@
  *
  * @param wnd Window
+ * @return EOK on success or an error code
  */
 errno_t ds_window_post_unfocus_event(ds_window_t *wnd)
 {
+	display_wnd_unfocus_ev_t eunfocus;
+	errno_t rc;
+	ds_wmclient_t *wmclient;
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_post_unfocus_event");
 
-	return ds_client_post_unfocus_event(wnd->client, wnd);
+	/* Decrease focus counter */
+	--wnd->nfocus;
+	eunfocus.nfocus = wnd->nfocus;
+
+	rc = ds_client_post_unfocus_event(wnd->client, wnd, &eunfocus);
+	if (rc != EOK)
+		return rc;
+
+	/* Notify window managers about window information change */
+	wmclient = ds_display_first_wmclient(wnd->display);
+	while (wmclient != NULL) {
+		ds_wmclient_post_wnd_changed_event(wmclient, wnd->id);
+		wmclient = ds_display_next_wmclient(wmclient);
+	}
+
+	return EOK;
 }
 
@@ -661,7 +769,8 @@
  * @param pos Position where the pointer was when the move started
  *            relative to the window
+ * @param pos_id Positioning device ID
  * @param event Button press event
  */
-void ds_window_move_req(ds_window_t *wnd, gfx_coord2_t *pos)
+void ds_window_move_req(ds_window_t *wnd, gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	gfx_coord2_t orig_pos;
@@ -671,5 +780,5 @@
 
 	gfx_coord2_add(&wnd->dpos, pos, &orig_pos);
-	ds_window_start_move(wnd, &orig_pos);
+	ds_window_start_move(wnd, &orig_pos, pos_id);
 }
 
@@ -691,4 +800,13 @@
 {
 	*dpos = wnd->dpos;
+}
+
+/** Get maximized window rectangle.
+ *
+ * @param wnd Window
+ */
+void ds_window_get_max_rect(ds_window_t *wnd, gfx_rect_t *rect)
+{
+	*rect = wnd->display->max_rect;
 }
 
@@ -699,16 +817,17 @@
  * @param pos Position where the pointer was when the resize started
  *            relative to the window
+ * @param pos_id Positioning device ID
  * @param event Button press event
  */
 void ds_window_resize_req(ds_window_t *wnd, display_wnd_rsztype_t rsztype,
-    gfx_coord2_t *pos)
+    gfx_coord2_t *pos, sysarg_t pos_id)
 {
 	gfx_coord2_t orig_pos;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_resize_req (%d, %d, %d)",
-	    (int) rsztype, (int) pos->x, (int) pos->y);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "ds_window_resize_req (%d, %d, %d, %d)",
+	    (int)rsztype, (int)pos->x, (int)pos->y, (int)pos_id);
 
 	gfx_coord2_add(&wnd->dpos, pos, &orig_pos);
-	ds_window_start_resize(wnd, rsztype, &orig_pos);
+	ds_window_start_resize(wnd, rsztype, &orig_pos, pos_id);
 }
 
@@ -716,4 +835,5 @@
  *
  * @param wnd Window
+ * @return EOK on success or an error code
  */
 errno_t ds_window_resize(ds_window_t *wnd, gfx_coord2_t *offs,
@@ -766,5 +886,113 @@
 	wnd->rect = *nrect;
 
+	if ((wnd->flags & wndf_avoid) != 0)
+		ds_display_update_max_rect(wnd->display);
+
 	(void) ds_display_paint(wnd->display, NULL);
+	return EOK;
+}
+
+/** Minimize window.
+ *
+ * @param wnd Window
+ * @return EOK on success or an error code
+ */
+errno_t ds_window_minimize(ds_window_t *wnd)
+{
+	/* If already minimized, do nothing and return success. */
+	if ((wnd->flags & wndf_minimized) != 0)
+		return EOK;
+
+	ds_window_unfocus(wnd);
+
+	wnd->flags |= wndf_minimized;
+	(void) ds_display_paint(wnd->display, NULL);
+	return EOK;
+}
+
+/** Unminimize window.
+ *
+ * @param wnd Window
+ * @return EOK on success or an error code
+ */
+errno_t ds_window_unminimize(ds_window_t *wnd)
+{
+	/* If not minimized, do nothing and return success. */
+	if ((wnd->flags & wndf_minimized) == 0)
+		return EOK;
+
+	wnd->flags &= ~wndf_minimized;
+	(void) ds_display_paint(wnd->display, NULL);
+	return EOK;
+}
+
+/** Maximize window.
+ *
+ * @param wnd Window
+ * @return EOK on success or an error code
+ */
+errno_t ds_window_maximize(ds_window_t *wnd)
+{
+	gfx_coord2_t old_dpos;
+	gfx_rect_t old_rect;
+	gfx_coord2_t offs;
+	gfx_rect_t max_rect;
+	gfx_rect_t nrect;
+	errno_t rc;
+
+	/* If already maximized, do nothing and return success. */
+	if ((wnd->flags & wndf_maximized) != 0)
+		return EOK;
+
+	/* Remember the old window rectangle and display position */
+	old_rect = wnd->rect;
+	old_dpos = wnd->dpos;
+
+	ds_window_get_max_rect(wnd, &max_rect);
+
+	/* Keep window contents on the same position on the screen */
+	offs.x = max_rect.p0.x - wnd->dpos.x;
+	offs.y = max_rect.p0.y - wnd->dpos.y;
+
+	/* Maximized window's coordinates will start at 0,0 */
+	gfx_rect_rtranslate(&max_rect.p0, &max_rect, &nrect);
+
+	rc = ds_window_resize(wnd, &offs, &nrect);
+	if (rc != EOK)
+		return rc;
+
+	/* Set window flags, remember normal rectangle */
+	wnd->flags |= wndf_maximized;
+	wnd->normal_rect = old_rect;
+	wnd->normal_dpos = old_dpos;
+
+	return EOK;
+}
+
+/** Unmaximize window.
+ *
+ * @param wnd Window
+ * @return EOK on success or an error code
+ */
+errno_t ds_window_unmaximize(ds_window_t *wnd)
+{
+	gfx_coord2_t offs;
+	errno_t rc;
+
+	/* If not maximized, do nothing and return success. */
+	if ((wnd->flags & wndf_maximized) == 0)
+		return EOK;
+
+	/* Keep window contents on the same position on the screen */
+	offs.x = wnd->normal_dpos.x - wnd->dpos.x;
+	offs.y = wnd->normal_dpos.y - wnd->dpos.y;
+
+	rc = ds_window_resize(wnd, &offs, &wnd->normal_rect);
+	if (rc != EOK)
+		return rc;
+
+	/* Clear maximized flag */
+	wnd->flags &= ~wndf_maximized;
+
 	return EOK;
 }
@@ -812,4 +1040,5 @@
  *
  * @param wnd Window
+ * @param cursor New cursor
  * @return EOK on success, EINVAL if @a cursor is invalid
  */
@@ -825,4 +1054,158 @@
 }
 
+/** Set window caption.
+ *
+ * @param wnd Window
+ * @param caption New caption
+ *
+ * @return EOK on success, EINVAL if @a cursor is invalid
+ */
+errno_t ds_window_set_caption(ds_window_t *wnd, const char *caption)
+{
+	char *dcaption;
+	ds_wmclient_t *wmclient;
+
+	dcaption = str_dup(caption);
+	if (dcaption == NULL)
+		return ENOMEM;
+
+	free(wnd->caption);
+	wnd->caption = dcaption;
+
+	/* Notify window managers about window information change */
+	wmclient = ds_display_first_wmclient(wnd->display);
+	while (wmclient != NULL) {
+		ds_wmclient_post_wnd_changed_event(wmclient, wnd->id);
+		wmclient = ds_display_next_wmclient(wmclient);
+	}
+
+	return EOK;
+}
+
+/** Find alternate window with the allowed flags.
+ *
+ * An alternate window is a *different* window that is preferably previous
+ * in the display order and only has the @a allowed flags.
+ *
+ * @param wnd Window
+ * @param allowed_flags Bitmask of flags that the window is allowed to have
+ *
+ * @return Alternate window matching the criteria or @c NULL if there is none
+ */
+ds_window_t *ds_window_find_prev(ds_window_t *wnd,
+    display_wnd_flags_t allowed_flags)
+{
+	ds_window_t *nwnd;
+
+	/* Try preceding windows in display order */
+	nwnd = ds_display_next_window(wnd);
+	while (nwnd != NULL && (nwnd->flags & ~allowed_flags) != 0) {
+		nwnd = ds_display_next_window(nwnd);
+	}
+
+	/* Do we already have a matching window? */
+	if (nwnd != NULL && (nwnd->flags & ~allowed_flags) == 0) {
+		return nwnd;
+	}
+
+	/* Try succeeding windows in display order */
+	nwnd = ds_display_first_window(wnd->display);
+	while (nwnd != NULL && nwnd != wnd &&
+	    (nwnd->flags & ~allowed_flags) != 0) {
+		nwnd = ds_display_next_window(nwnd);
+	}
+
+	if (nwnd == wnd)
+		return NULL;
+
+	return nwnd;
+}
+
+/** Find alternate window with the allowed flags.
+ *
+ * An alternate window is a *different* window that is preferably previous
+ * in the display order and only has the @a allowed flags.
+ *
+ * @param wnd Window
+ * @param allowed_flags Bitmask of flags that the window is allowed to have
+ *
+ * @return Alternate window matching the criteria or @c NULL if there is none
+ */
+ds_window_t *ds_window_find_next(ds_window_t *wnd,
+    display_wnd_flags_t allowed_flags)
+{
+	ds_window_t *nwnd;
+
+	/* Try preceding windows in display order */
+	nwnd = ds_display_prev_window(wnd);
+	while (nwnd != NULL && (nwnd->flags & ~allowed_flags) != 0) {
+		nwnd = ds_display_prev_window(nwnd);
+	}
+
+	/* Do we already have a matching window? */
+	if (nwnd != NULL && (nwnd->flags & ~allowed_flags) == 0) {
+		return nwnd;
+	}
+
+	/* Try succeeding windows in display order */
+	nwnd = ds_display_last_window(wnd->display);
+	while (nwnd != NULL && nwnd != wnd &&
+	    (nwnd->flags & ~allowed_flags) != 0) {
+		nwnd = ds_display_prev_window(nwnd);
+	}
+
+	if (nwnd == wnd)
+		return NULL;
+
+	return nwnd;
+}
+
+/** Remove focus from window.
+ *
+ * Used to switch focus to another window when closing or minimizing window.
+ *
+ * @param wnd Window
+ */
+void ds_window_unfocus(ds_window_t *wnd)
+{
+	ds_seat_t *seat;
+
+	/* Make sure window is no longer focused in any seat */
+	seat = ds_display_first_seat(wnd->display);
+	while (seat != NULL) {
+		ds_seat_unfocus_wnd(seat, wnd);
+		seat = ds_display_next_seat(seat);
+	}
+}
+
+/** Determine if input device belongs to the same seat as the original device.
+ *
+ * Compare the seat ownning @a idev_id with the seat owning @a wnd->orig_pos_id
+ * (the device that started the window move or resize).
+ *
+ * This is used to make sure that, when two seats focus the same window,
+ * only devices owned by the seat that started the resize or move can
+ * affect it. Otherwise moving the other pointer(s) would disrupt the
+ * resize or move operation.
+ *
+ * @param wnd Window (that is currently being resized or moved)
+ * @param idev_id Input device ID
+ * @return @c true iff idev_id is owned by the same seat as the input
+ *         device that started the resize or move
+ */
+bool ds_window_orig_seat(ds_window_t *wnd, sysarg_t idev_id)
+{
+	ds_seat_t *orig_seat;
+	ds_seat_t *seat;
+
+	/* Window must be in state such that wnd->orig_pos_id is valid */
+	assert(wnd->state == dsw_moving || wnd->state == dsw_resizing);
+
+	orig_seat = ds_display_seat_by_idev(wnd->display, wnd->orig_pos_id);
+	seat = ds_display_seat_by_idev(wnd->display, idev_id);
+
+	return seat == orig_seat;
+}
+
 /** Window memory GC invalidate callback.
  *
